<?php // $Id: mlm.backends.inc,v 1.2 2009/08/23 23:06:27 vauxia Exp $

/**
 * Gather information about MLM backends.
 */
function mlm_backend_info() {
  $backends = module_invoke_all('mlm_backend_info');
  foreach ($backends as $name => $info) {
    if (!isset($info['module'])) $handlers[$type][$name]['module'] = $name;
    if (!isset($info['backend'])) $handlers[$type][$name]['backend'] = $name;
  }
  return $backends;
}

/**
 * Implementation of our own hook_mlm_backend_info()
 */
function mlm_mlm_backend_info() {
  $path = drupal_get_path('module', 'mlm'). '/backend';

  return array(
    'mlm_drupal' => array(
      'title' => t('Drupal'),
      'path' => $path,
      'description' => t('A native Drupal backend for storing user subscriptions.'),
    ),
    'mlm_ezmlm' => array(
      'title' => t('ezmlm'),
      'path' => $path,
      'description' => t('Support for the EZMLM mailing list server. You must have the lists configured separately, but they do not need to be on the same server.'),
    ),
    'mlm_ezmlm_idx' => array(
      'title' => t('ezmlm-idx'),
      'parent' => t('mlm_ezmlm'),
      'path' => $path,
      'description' => t('Extended support for EZMLM. Use this if you are using EZMLM with IDX extensions and this site has access to the the database that is storing subscriptions.'),
    ),
  );
}

/**
 * Gather information about MLM list types.
 */
function mlm_list_type_info() {
  static $types;
  if (!isset($types)) {
    $types = module_invoke_all('mlm_list_type_info');
  }
  return $types;
}

/**
 * Implementation of our own hook_mlm_list_type_info().
 */
function mlm_mlm_list_type_info() {
  return array(
    'announcement' => array(
      'title' => t('Announcement'),
    ),
    'discussion' => array(
      'title' => t('Discussion'),
    ),
  );
}
