<?php // $Id: mlm_drupal.inc,v 1.3 2009/08/10 01:09:32 vauxia Exp $

/**
 * @file
 * Drupal backend for the MLM module.
 */

class mlm_drupal extends mlm {

  function settings_form($node_type = NULL) {
    if (variable_get('mimemail_incoming', FALSE)) {
      $form['mlm_drupal_incoming_address'] = array(
        '#type' => 'textfield',
        '#title' => t('Incoming address'),
        '#default_value' => variable_get('mlm_drupal_incoming_address', ''),
        '#description' => t('Handle incoming posts and replies sent to this address.'),
      );
    }
  }

  function delete() {
    return (bool) db_query("DELETE FROM {mlm_drupal} WHERE lid = %d", $this->lid);
  }

  function subscribe() {
    return (bool)db_query("INSERT INTO {mlm_drupal} (lid, mail, uid, timestamp)
      VALUES ( '%s', '%s', %d, %d )", $this->lid, $this->account->mail, $this->account->uid, time());
  }

  function unsubscribe() {
    return (bool) db_query("DELETE FROM {mlm_drupal}
      WHERE lid = %d AND ( mail = '%s' OR (uid != 0 AND uid = %d ))", $this->lid, $this->account->mail, $this->account->uid);
  }

  function is_subscribed() {
    return (bool) db_result(db_query("SELECT 1 FROM {mlm_drupal} m
      WHERE m.lid = %d AND (m.mail = '%s' OR ( m.uid != 0 AND m.uid = %d))"
      , $this->lid, $this->account->mail, $this->account->uid));
  }

  function count() {
    return (int) db_result(db_query("SELECT COUNT(1) FROM {mlm_drupal}
      WHERE lid = %d", $this->lid));
  }

  function subscriber_fields() {
    return array('mail' => t('E-mail'), 'name' => t('Username'));
  }

  function subscribers($limit = NULL) {
    $func = 'db_query';
    $sql = array("SELECT COALESCE(m.mail, u.mail) AS mail, u.name
      FROM {mlm_drupal} m LEFT OUTER JOIN {users} u USING ( mail )
      WHERE m.lid = %d ORDER BY name");

    if ($limit) {
      $func = 'pager_query';
      $sql[] = $limit;
      $sql[] = 1;
      $sql[] = NULL;
    }
    $sql[] = $this->lid;

    return call_user_func_array($func, $sql);
  }

  function post($message, $account = NULL) {
    // TODO queue these!
    // TODO tokens!
    $subscribers = $this->subscribers();

    if (!isset($message['headers'])) $message['headers'] = array();
    $message['headers']['Precedence'] = 'list';
    // TODO set these properly.
    $message['headers']['List-Id'] = '';
    $message['headers']['List-Unsubscribe'] = '<'. url($this->path() .'/unsubscribe', array('absolute' => TRUE)) .'>';
    $message['headers']['List-Subscribe'] = '<'. url($this->path() .'/subscribe', array('absolute' => TRUE)) .'>';
    $message['headers']['List-Owner'] = '';
    $message['headers']['List-Archive'] = '';
    $message['headers']['List-Help'] = '<'. url($this->path(), array('absolute' => TRUE)) .'>';
    $message['headers']['List-Post'] = ''; // 'NO' or a post address.

    while ($row = db_fetch_object($subscribers)) {
      mimemail($message['sender'], $row, $message['subject'], $message['body'], NULL, $message['headers']);
    }
  }

  function post_address() {
    $res = db_query(db_rewrite_sql("SELECT u.uid,
          COALESCE(m.mail, u.mail) AS mail,
          COALESCE(u.name, m.mail) AS name,
          COALESCE(u.uid, 0) AS uid
        FROM {mlm_drupal} m LEFT OUTER JOIN {users} u USING ( mail )
        WHERE m.lid = %d ORDER BY mail", $primary_table = 'm'), $this->lid); // must identify primary_table to avoid issues
  
    $recipients = array();
    while ($row = db_fetch_array($res)) {
      $recipients[] = $row;
    }
    return $recipients;
  }
}
