<?php // $Id: mlm_ezmlm.inc,v 1.3 2009/08/23 23:06:28 vauxia Exp $

/**
 * @file
 * EZMLM backend for the MLM module.
 */

class mlm_ezmlm extends mlm {

  var $ezmlm_address = NULL;

  function edit_form($form) {
    $edit_form['address'] = array(
      '#type'          => 'textfield',
      '#title'         => t('E-mail Address'),
      '#default_value' => $this->settings('address'),
      '#description'   => t('A mailing list must be configured on your mail server before you can use it on your site. Enter its e-mail address here.'),
    );
    return $edit_form;
  }

  function edit_form_validate(&$form, $form_state, $values) {
    if (!$values['address']) {
      form_set_error('address', t('E-mail address is required'));
    }
    if (!valid_email_address($values['address'])) {
      form_set_error('address', t('Invalid mail address format'));
    }
  }

  function subscribe() {
    $action = '-subscribe-'. str_replace('@', '=', $this->account->mail);
    $address = str_replace('@', "{$action}@", $this->ezmlm_address);
    return mimemail($this->account, $address, 'unsubscribe', '');
  }

  function unsubscribe() {
    $action = '-unsubscribe-'. str_replace('@', '=', $this->account->mail);
    $address = str_replace('@', "{$action}@", $this->ezmlm_address);
    return mimemail($this->account, $address, 'unsubscribe', '');
  }

  function post_address() {
    return $this->ezmlm_address;
  }
}
