<?php // $Id: mlm.batch.inc,v 1.1 2009/02/22 22:35:41 vauxia Exp $

/**
 * @file
 *
 * Batch API functions for lengthy MLM operations.
 */

/**
 * All-purpose handler for batch operations.
 */
function mlm_batch_done($success, $results, $operations) {
  if ($message = array_shift($results)) {
    drupal_set_message($message);
  }
}

/**
 * Batch handler for long-running list file import operations.
 */
function mlm_batch_import($lid, $file, $notify, &$context) {
  ini_set('auto_detect_line_endings', TRUE);
  $list = mlm_load($lid);

  // This is a new batch.
  if (empty($context['sandbox'])) {
    $context['sandbox']['fpos'] = 0;
    $context['sandbox']['count'] = 0;
    $context['sandbox']['fail'] = 0;
    $context['finished'] = $context['fpos'] / $file->filesize;
  }
  if (!$fp = fopen($file->filepath, 'r')) {
    drupal_set_message(t('Error opening file'), 'error');
    $context['finished'] = 1;
  }

  if ($context['finished'] < 1) {
    $records = 0;
    fseek($fp, $context['sandbox']['fpos']);
    while (($records++ < 50) && $row = fgetcsv($fp, 4096)) {
      $mail = $row[0]; // TODO map fields more appropriately.
      if (valid_email_address($mail)) {
        $list->_subscribe($mail, $notify) && $ret;
        $context['sandbox']['count']++;
      }
      else {
        $context['results'][] = (t('%mail is not a valid email address', array('%mail' => $mail)));
        $context['sandbox']['fail']++;
      }
      $context['sandbox']['fpos'] = ftell($fp);
      $context['finished'] = $context['fpos'] / $file->filesize;
    }
  }
 
  if ($context['finished'] == 1) {
    $status = t('%count records imported with %fail errors.', array('%count' => $context['sandbox']['count'], '%fail' => $context['sandbox']['fail']));
    array_unshift($context['results'], $status);
    db_query("DELETE FROM {files} WHERE fid = %d", $file->fid);
    file_delete($file->filename);
  }
}

/**
 * Batch handler for long-running list posting operations.
 */
function mlm_batch_post($list, &$context) {
}
