<?php // $Id: mlm.form.inc,v 1.3 2009/08/23 23:06:28 vauxia Exp $

/**
 * List creation and editing form.
 */
function mlm_form($form_state, $mlm = NULL) {
  if (!$mlm) {
    if (count($backends = mlm_backend_names()) == 1) {
      $mlm = mlm_load(key($backends));
    }
    elseif (isset($form_state['storage']['set_mlm_list'])) {
      $mlm = mlm_load($form_state['storage']['set_mlm_list']);
    }
    else {
      // List type selection form.
      $form['set_mlm_list'] = array(
        '#type' => 'select',
        '#title' => t('Mailing list backend'),
        '#options' => $backends,
      );
      $form['submit'] = array(
        '#type' => 'submit',
        '#value' => t('Next'),
      );
    }
  }
  if ($mlm) {
    $form = $mlm->_edit_form($form_state);

    $title = $mlm->lid ? $mlm->title() : t('Add a list');
    drupal_set_title($title);

    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Submit'),
    );
  }

  return $form;
}

/**
 * Validation handler for list creation.
 */
function mlm_form_validate($form, &$form_state) {
  if (isset($form_state['values']['backend'])) {
    $mlm = mlm_load($form_state['values']);
    $mlm->_edit_form_validate($form, $form_state, $form_state['values']);
  }
}

/**
 * Submit handler for list creation.
 */
function mlm_form_submit($form, &$form_state) {
  if ($form_state['values']['set_mlm_list']) {
    if (!count($form_state['storage'])) {
      $form_state['storage'] = $form_state['values'];
      $form_state['rebuild'] = TRUE;
    }
    return;
  }
  if (isset($form_state['values']['backend'])) {
    $mlm = mlm_load($form_state['values']);
    $mlm->_edit_form_submit($form, $form_state, $form_state['values']);
    $mlm->_save();
    unset($form_state['rebuild'], $form_state['storage']);
    $form_state['redirect'] = $mlm->path();
  }
}
