<?php // $Id: mlm.menu.inc,v 1.10 2009/08/26 02:51:34 vauxia Exp $

/**
 * @file
 * Menu settings for Mailing List Manager.
 */

/**
 * Implementation of hook_menu().
 */
function mlm_menu_menu() {
  $items = array();
  $path = drupal_get_path('module', 'mlm') .'/include';

  $items['mlm'] = array(
    'title' => 'Subscription preferences',
    'page callback' => 'drupal_get_form',
    'page arguments' => array('mlm_subscription_page'),
    'access arguments' => array('subscribe to mailing lists'),
    'file' => 'mlm.subscription.inc',
    'file path' => $path,
    'type' => MENU_SUGGESTED_ITEM
  );

  $items['admin/build/mlm'] = array(
    'title' => 'Mailing lists',
    'description' => 'Manage mailing lists and subscribers',
    'access arguments' => array('administer mlm'),
    'page callback' => 'mlm_admin_list_overview',
    'file' => 'admin.inc',
    'file path' => $path,
  );

  $items['admin/build/mlm/list'] = array(
    'title' => 'Lists',
    'type' => MENU_DEFAULT_LOCAL_TASK,
    'weight' => -10,
  );

  $items['admin/build/mlm/add'] = array(
    'title' => 'Add',
    'access arguments' => array('administer mlm'),
    'page callback' => 'drupal_get_form',
    'page arguments' => array('mlm_form'),
    'type' => MENU_LOCAL_TASK,
    'file' => 'mlm.form.inc',
    'file path' => $path,
  );

  $items['admin/build/mlm/settings'] = array(
    'title' => 'Settings',
    'access arguments' => array('administer mlm'),
    'page callback' => 'drupal_get_form',
    'page arguments' => array('mlm_admin_settings'),
    'file' => 'admin.inc',
    'file path' => $path,
    'type' => MENU_LOCAL_TASK,
    'weight' => 10,
  );

  $items['mlm/%mlm'] = array(
    'access callback' => 'mlm_access',
    'access arguments' => array(1),
    'page callback' => 'theme',
    'page arguments' => array('mlm', 1),
    'access callback' => 'mlm_access',
    'access arguments' => array(1),
    'type' => MENU_CALLBACK
  );
  
  $items['mlm/%mlm/edit'] = array(
    'title' => 'Edit',
    'access callback' => 'mlm_access',
    'access arguments' => array(1, 'edit'),
    'page callback' => 'drupal_get_form',
    'page arguments' => array('mlm_form', 1),
    'type' => MENU_LOCAL_TASK,
    'file' => 'mlm.form.inc',
    'file path' => $path,
  );

  $items['mlm/%mlm/%'] = array(
    'page callback' => 'mlm_subscription_callback',
    'page arguments' => array(1, 2),
    'access callback' => 'mlm_access',
    'access arguments' => array(1),
    'file' => 'mlm.subscription.inc',
    'file path' => $path,
    'type' => MENU_CALLBACK,
  );
  $items['mlm/%mlm/view'] = array(
    'title' => 'View',
    'page callback' => 'theme',
    'page arguments' => array('mlm', 1),
    'access callback' => 'mlm_access',
    'access arguments' => array(1),
    'type' => MENU_DEFAULT_LOCAL_TASK,
    'weight' => -10,
  );
  $items['mlm/%mlm/subscribers'] = array(
    'title' => 'Subscribers',
    'page callback' => 'mlm_subscribers_overview',
    'page arguments' => array(1),
    'access callback' => 'mlm_access',
    'access arguments' => array(1, 'manage'),
    'file' => 'mlm.subscribers.inc',
    'file path' => $path,
    'type' => MENU_LOCAL_TASK,
  );
  return $items;
}
