<?php // $Id: mlm.subscribers.inc,v 1.2 2009/08/23 23:06:28 vauxia Exp $

/**
 * Subscription import/export form on an MLM list.
 */
function mlm_subscribers_overview($list) {
  drupal_set_title($list->title());
  $output = '';
  $output .= drupal_get_form('mlm_subscribers_import_form', $list);
  $output .= drupal_get_form('mlm_subscribers_export_form', $list);
  $output .= mlm_subscribers_list($list);
  return $output;
}

/**
 * A bulk import form for mailing list subscribers.
 */
function mlm_subscribers_import_form($form_state, $list) {
  if ($form = $list->import_form($form_state)) {
    $form['#mlm_list'] = $list;
    $form['mlm']['#type'] = 'fieldset';
    $form['mlm']['#title'] = ('Import subscribers');
    $form['mlm']['#collapsible'] = TRUE;
    $form['mlm']['#collapsed'] = TRUE;

    foreach(element_children($form) as $key) {
      if ($key != 'mlm') {
        $form['mlm'][$key] = $form[$key];
        unset($form[$key]);
      }
    }
  }
  return $form;
}

/**
 * Submit hook for a subscription import form on an MLM list.
 */
function mlm_subscribers_import_form_submit($form, &$form_state) {
  $form['#mlm_list']->import_form_submit($form, $form_state);
}

/**
 * A bulk export form for mailing list subscribers.
 */
function mlm_subscribers_export_form($form_state, $list) {
  if ($mlm_form = $list->export_form($form_state)) {
    $form['#mlm_list'] = $list;
    $form['mlm'] = $mlm_form;
    $form['mlm']['#type'] = 'fieldset';
    $form['mlm']['#title'] = ('Export subscribers');
    $form['mlm']['#collapsible'] = TRUE;
    $form['mlm']['#collapsed'] = TRUE;
  }
  return $form;
}

/**
 * Submit hook for a subscription export form on an MLM list.
 */
function mlm_subscribers_export_form_submit($form, &$form_state) {
  $form['#mlm_list']->export_form_submit($form_state['values']);
}

/**
 * List of subscribers, in table form.
 */
function mlm_subscribers_list($list) {
  $hdrs = array_merge($list->subscriber_fields(), array(('operations')));
  $rows = array();
  $res = $list->subscribers(100);
  while ($row = db_fetch_array($res)) {
    $row[] = l(t('unsubscribe'), 'mlm/'. $list->lid .'/unsubscribe/'. current($row), array('query' => 'destination='. $_GET['q']));
    $rows[] = $row;
  }

  // Nothing to see here!
  if (!$rows) return;

  $output .= theme('table', $hdrs, $rows);
  $output .= theme('pager', NULL, 100, 0);
  return $output;
}
