<?php // $Id: mlm_views.inc,v 1.2 2009/05/20 21:07:45 vauxia Exp $

class mlm_views extends mlm_drupal {
  var $name = 'Views';
  var $backend = 'mlm_views';
  var $description = 'A views-based Drupal backend';
  var $supported_types = array('announcement');
  var $parent = 'mlm_drupal';

  var $view;

  function edit_form() {
    $form = array();
    $views = $fields = array();
    foreach (views_get_all_views() as $view) {
      $views[$view->name] = array();
      $view->init_display();
      foreach ($view->display as $display_id => $display) {
        if ($fields = $display->display_options['fields']) {
          $views[$view->name][$display_id] = $display->display_title;
          $fields[$view->name][$display_id] = $fields;
        }
      }
    }

    $form['view'] = array(
      '#type' => 'select',
      '#title' => t('View name'),
      '#options' => $views,
      '#default_value' => $this->options['view'],
      '#required' => TRUE,
    );
    $form['mlm_field'] = array(
      '#type' => 'select',
      '#title' => t('Field'),
      '#options' => $fields['tracker'],
      '#default_value' => $this->options['mlm_field'],
      '#required' => FALSE,
    );
    return $form;
  }

  /**
   * Override the subscribers form because there's no way to add users.
   */
  function import_form($form_state) {
    return array();
  }

  function subscribe_form() {
    // No real capacity to subscribe here.
    return array();
  }
}
