<?php // $Id: mlm.theme.inc,v 1.4 2009/08/26 02:51:34 vauxia Exp $

/**
 * Implementation of hook_theme().
 */
function mlm_theme_theme() {
  $path = drupal_get_path('module', 'mlm') .'/theme';
  return array(
    'mlm' => array(
      'file' => 'mlm.theme.inc',
      'path' => $path,
    ),
    'mlm_subscription' => array(
      'arguments' => array( 'element' => NULL ),
      'file' => 'mlm.theme.inc',
      'path' => $path,
    ),
    'mlm_archive_text' => array(
      'arguments' => array( 'body' => NULL ),
      'file' => 'mlm.theme.inc',
      'path' => $path,
    ),
    'mlm_post_subject' => array(
      'arguments' => array( 'list' => NULL, 'subject' => NULL ),
      'file' => 'mlm.theme.inc',
      'path' => $path,
    ),
    'mlm_post_body' => array(
      'arguments' => array( 'list' => NULL, 'body' => NULL ),
      'file' => 'mlm.theme.inc',
      'path' => $path,
    ),
    'mlm_post_trailer' => array(
      'arguments' => array( 'list' => NULL ),
      'file' => 'mlm.theme.inc',
      'path' => $path,
    ),
  );
}

function theme_mlm($mlm) {
  drupal_set_title($mlm->title());
  $output = $mlm->description();

  $output .= drupal_get_form('mlm_view_form', $mlm);
  return $output;
}

function theme_mlm_subscription($element) {
  return theme('form_element', $element, $element['#children']);
}

/*
 * TODO abstract this better!  input filter to convert data? add to mimemail?
 */
function theme_mlm_archive_text($text) {

  // Convert all Windows and Mac newlines to a single newline,
  // so filters only need to deal with one possibility.
  $text = str_replace(array("\r\n", "\r"), "\n", $text);

  // If this is HTML, we're only interested in the body content
  $text = preg_replace('/(.*<body[^>]*>)?(.*?)(<\/body>.*)?/is', '\2', $text);

  // Down with top-quoting!
  //This works, but only with some versions of Outlook:
  //$text = preg_replace('/(.*?)(<blockquote.*)?-----Original Message-----.*/is', '\1', $text);

  $text = preg_replace('/(.*?)From:.{1,200}Sent:.{1,100}To:.{1,200}.*/is', '\1', $text);

  // TODO Strip MSN and Yahoo signatures
  // $text = preg_replace('/(<hr[^>]>|-{5,}\n)(.*\n){0,2}.*(msn|yahoo)[^\n]\n/i', '', $text);

  // TODO Get rid of trailing rows containing entirely >'s and whitespace
  //$striplength = strspn(strrev($text),"> \t\n\r");
  //if($striplength) {
    //$text = substr($text,0,-$striplength);
  //}

  // TODO Convert mail-based brackets into quote markup
  //if ( module_exists('quote')) {
    //$text = preg_replace('/((<br[^>]*>)\s?(&gt;)([^<]*)/im)+/i', '[quote]\2\4[/quote]', $text);
  //}

  return $text;
}

/**
 * Subject line for MLM posts sent by e-mail.
 * @ingroup themeable
 */
function theme_mlm_post_subject($list, $subject) {
  $prefix = '';
  //if ($mlm->mlm_list_type == 'discussion') {
    $prefix = '['. variable_get('site_name', 'Drupal') .'] ';
  //}
  $subject = preg_replace($prefix, '', $subject);
  $subject = preg_replace('/^(\s*RE\s?:\s*)+/i', "Re: $prefix", $subject, -1, $c);
  if (!$c) $subject = $prefix . $subject;
  return $subject;
}

/**
 * Message body for MLM posts sent by e-mail.
 * @ingroup themeable
 */
function theme_mlm_post_body($list, $body) {
  return $body . theme('mlm_post_trailer', $list);
}

/**
 * Message trailer for MLM posts sent by e-mail.
 * @ingroup themeable
 */
function theme_mlm_post_trailer($list) {
  $out = '';
  return $out;
}
